diff -Nur olsrd-0.5.0.cvs/lib/bmf/src/NetworkInterfaces.h olsrd-0.5.0/lib/bmf/src/NetworkInterfaces.h
--- olsrd-0.5.0.cvs/lib/bmf/src/NetworkInterfaces.h	2007-06-23 13:15:19.000000000 +0200
+++ olsrd-0.5.0/lib/bmf/src/NetworkInterfaces.h	2007-05-08 10:33:08.000000000 +0200
@@ -3,7 +3,7 @@
 
 /*
  * OLSR Basic Multicast Forwarding (BMF) plugin.
- * Copyright (c) 2005, 2006, Thales Communications, Huizen, The Netherlands.
+ * Copyright (c) 2005 - 2007, Thales Communications, Huizen, The Netherlands.
  * Written by Erik Tromp.
  * All rights reserved.
  *
@@ -117,25 +117,28 @@
 
 extern int CapturePacketsOnOlsrInterfaces;
 
-enum TTunOrTap { TT_TUN = 0, TT_TAP };
-extern enum TTunOrTap TunOrTap;
-
 enum TBmfMechanism { BM_BROADCAST = 0, BM_UNICAST_PROMISCUOUS };
 extern enum TBmfMechanism BmfMechanism;
 
 int SetBmfInterfaceName(const char* ifname);
-int SetBmfInterfaceType(const char* iftype);
 int SetBmfInterfaceIp(const char* ip);
 int SetCapturePacketsOnOlsrInterfaces(const char* enable);
 int SetBmfMechanism(const char* mechanism);
 int DeactivateSpoofFilter(void);
 void RestoreSpoofFilter(void);
-struct link_entry* GetBestNeighbor(
+
+struct TBestNeighbors
+{
+  struct link_entry* links[2];
+};
+
+struct TBestNeighbors GetBestTwoNeighbors(
   struct TBmfInterface* intf,
   union olsr_ip_addr* source,
   union olsr_ip_addr* forwardedBy,
   union olsr_ip_addr* forwardedTo,
-  int* multipleNeighbors);
+  int* nPossibleNeighbors);
+
 int CreateBmfNetworkInterfaces(struct interface* skipThisIntf);
 void AddInterface(struct interface* newIntf);
 void CloseBmfNetworkInterfaces(void);
diff -Nur olsrd-0.5.0.cvs/lib/bmf/src/olsrd_plugin.c olsrd-0.5.0/lib/bmf/src/olsrd_plugin.c
--- olsrd-0.5.0.cvs/lib/bmf/src/olsrd_plugin.c	2007-06-23 13:15:19.000000000 +0200
+++ olsrd-0.5.0/lib/bmf/src/olsrd_plugin.c	2007-05-13 04:30:08.000000000 +0200
@@ -1,6 +1,6 @@
 /*
  * OLSR Basic Multicast Forwarding (BMF) plugin.
- * Copyright (c) 2005, 2006, Thales Communications, Huizen, The Netherlands.
+ * Copyright (c) 2005 - 2007, Thales Communications, Huizen, The Netherlands.
  * Written by Erik Tromp.
  * All rights reserved.
  *
diff -Nur olsrd-0.5.0.cvs/lib/bmf/src/Packet.c olsrd-0.5.0/lib/bmf/src/Packet.c
--- olsrd-0.5.0.cvs/lib/bmf/src/Packet.c	2007-06-23 13:15:19.000000000 +0200
+++ olsrd-0.5.0/lib/bmf/src/Packet.c	2007-05-08 10:33:08.000000000 +0200
@@ -1,6 +1,6 @@
 /*
  * OLSR Basic Multicast Forwarding (BMF) plugin.
- * Copyright (c) 2005, 2006, Thales Communications, Huizen, The Netherlands.
+ * Copyright (c) 2005 - 2007, Thales Communications, Huizen, The Netherlands.
  * Written by Erik Tromp.
  * All rights reserved.
  *
@@ -67,10 +67,10 @@
     return 1;
   }
   return 0;
-}
+} /* IsIpFragment */
 
 /* -------------------------------------------------------------------------
- * Function   : GetTotalLength
+ * Function   : GetIpTotalLength
  * Description: Retrieve the total length of the IP packet (in bytes) of
  *              an IP packet
  * Input      : ipPacket - the IP packet
@@ -78,7 +78,7 @@
  * Return     : IP packet length
  * Data Used  : none
  * ------------------------------------------------------------------------- */
-u_int16_t GetTotalLength(unsigned char* ipPacket)
+u_int16_t GetIpTotalLength(unsigned char* ipPacket)
 {
   struct iphdr* iph;
 
@@ -86,17 +86,17 @@
 
   iph = (struct iphdr*) ipPacket;
   return ntohs(iph->tot_len);
-}
+} /* GetIpTotalLength */
 
 /* -------------------------------------------------------------------------
- * Function   : GetHeaderLength
+ * Function   : GetIpHeaderLength
  * Description: Retrieve the IP header length (in bytes) of an IP packet
  * Input      : ipPacket - the IP packet
  * Output     : none
  * Return     : IP header length
  * Data Used  : none
  * ------------------------------------------------------------------------- */
-unsigned int GetHeaderLength(unsigned char* ipPacket)
+unsigned int GetIpHeaderLength(unsigned char* ipPacket)
 {
   struct iphdr* iph;
 
@@ -104,7 +104,7 @@
 
   iph = (struct iphdr*) ipPacket;
   return iph->ihl << 2;
-}
+} /* GetIpHeaderLength */
 
 /* -------------------------------------------------------------------------
  * Function   : GetTtl
@@ -123,7 +123,7 @@
 
   iph = (struct iphdr*) ipPacket;
   return iph->ttl;
-}
+} /* GetTtl */
 
 /* -------------------------------------------------------------------------
  * Function   : SaveTtlAndChecksum
@@ -143,7 +143,7 @@
   iph = (struct iphdr*) ipPacket;
   sttl->ttl = iph->ttl;
   sttl->check = ntohs(iph->check);
-}
+} /* SaveTtlAndChecksum */
 
 /* -------------------------------------------------------------------------
  * Function   : RestoreTtlAndChecksum
@@ -164,7 +164,7 @@
   iph = (struct iphdr*) ipPacket;
   iph->ttl = sttl->ttl;
   iph->check = htons(sttl->check);
-}
+} /* RestoreTtlAndChecksum */
 
 /* -------------------------------------------------------------------------
  * Function   : DecreaseTtlAndUpdateHeaderChecksum
@@ -188,100 +188,44 @@
   iph->ttl--; /* decrement ttl */
   sum = ntohs(iph->check) + 0x100; /* increment checksum high byte */
   iph->check = htons(sum + (sum>>16)); /* add carry */
-}
-
-/* -------------------------------------------------------------------------
- * Function   : GetEtherType
- * Description: Retrieve the EtherType of an Ethernet frame
- * Input      : ethernetFrame - the Ethernet frame
- * Output     : none
- * Return     : EtherType
- * Data Used  : none
- * ------------------------------------------------------------------------- */
-u_int16_t GetEtherType(unsigned char* ethernetFrame)
-{
-  u_int16_t type;
-  memcpy(&type, ethernetFrame + ETH_TYPE_OFFSET, 2);
-  return ntohs(type);
-}
+} /* DecreaseTtlAndUpdateHeaderChecksum */
 
 /* -------------------------------------------------------------------------
  * Function   : GetIpHeader
- * Description: Retrieve the IP header from an Ethernet frame
- * Input      : ethernetFrame - the Ethernet frame
+ * Description: Retrieve the IP header from BMF encapsulation UDP data
+ * Input      : encapsulationUdpData - the encapsulation UDP data
  * Output     : none
  * Return     : IP header
  * Data Used  : none
  * ------------------------------------------------------------------------- */
-struct ip* GetIpHeader(unsigned char* ethernetFrame)
+struct ip* GetIpHeader(unsigned char* encapsulationUdpData)
 {
-  return (struct ip*)(ethernetFrame + IP_HDR_OFFSET);
-}
+  return (struct ip*)(encapsulationUdpData + ENCAP_HDR_LEN);
+} /* GetIpHeader */
 
 /* -------------------------------------------------------------------------
  * Function   : GetIpPacket
- * Description: Retrieve the IP packet from an Ethernet frame
- * Input      : ethernetFrame - the Ethernet frame
- * Output     : none
- * Return     : IP packet
- * Data Used  : none
- * ------------------------------------------------------------------------- */
-unsigned char* GetIpPacket(unsigned char* ethernetFrame)
-{
-  return ethernetFrame + IP_HDR_OFFSET;
-}
-
-/* -------------------------------------------------------------------------
- * Function   : GetFrameLength
- * Description: Return the Ethernet frame length of an Ethernet frame containing
- *              an IP packet
- * Input      : ethernetFrame - the Ethernet frame
- * Output     : none
- * Return     : The frame length
- * Data Used  : none
- * ------------------------------------------------------------------------- */
-u_int16_t GetFrameLength(unsigned char* ethernetFrame)
-{
-  return GetTotalLength(GetIpPacket(ethernetFrame)) + IP_HDR_OFFSET;
-}
-
-/* -------------------------------------------------------------------------
- * Function   : SetFrameSourceMac
- * Description: Set the source MAC address of an Ethernet frame
- * Input      : ethernetFrame - the Ethernet frame
-              : srcMac - the source MAC address
- * Output     : none
- * Return     : none
- * Data Used  : none
- * ------------------------------------------------------------------------- */
-void SetFrameSourceMac(unsigned char* ethernetFrame, unsigned char* srcMac)
-{
-  memcpy(ethernetFrame + IFHWADDRLEN, srcMac, IFHWADDRLEN);
-}
-
-/* -------------------------------------------------------------------------
- * Function   : GetEthernetFrame
- * Description: Retrieve the Ethernet frame from BMF encapsulation UDP data
+ * Description: Retrieve the IP packet from BMF encapsulation UDP data
  * Input      : encapsulationUdpData - the encapsulation UDP data
  * Output     : none
- * Return     : The Ethernet frame
+ * Return     : The IP packet
  * Data Used  : none
  * ------------------------------------------------------------------------- */
-unsigned char* GetEthernetFrame(unsigned char* encapsulationUdpData)
+unsigned char* GetIpPacket(unsigned char* encapsulationUdpData)
 {
   return encapsulationUdpData + ENCAP_HDR_LEN;
-}
+} /* GetIpPacket */
 
 /* -------------------------------------------------------------------------
  * Function   : GetEncapsulationUdpDataLength
  * Description: Return the length of BMF encapsulation UDP data
  * Input      : encapsulationUdpData - the encapsulation UDP data
  * Output     : none
- * Return     : The packet length
+ * Return     : The encapsulation data length
  * Data Used  : none
  * ------------------------------------------------------------------------- */
 u_int16_t GetEncapsulationUdpDataLength(unsigned char* encapsulationUdpData)
 {
-  return GetFrameLength(GetEthernetFrame(encapsulationUdpData)) + ENCAP_HDR_LEN;
-}
+  return GetIpTotalLength(GetIpPacket(encapsulationUdpData)) + ENCAP_HDR_LEN;
+} /* GetEncapsulationUdpDataLength */
 
diff -Nur olsrd-0.5.0.cvs/lib/bmf/src/Packet.h olsrd-0.5.0/lib/bmf/src/Packet.h
--- olsrd-0.5.0.cvs/lib/bmf/src/Packet.h	2007-06-23 13:15:19.000000000 +0200
+++ olsrd-0.5.0/lib/bmf/src/Packet.h	2007-05-08 10:33:08.000000000 +0200
@@ -3,7 +3,7 @@
 
 /*
  * OLSR Basic Multicast Forwarding (BMF) plugin.
- * Copyright (c) 2005, 2006, Thales Communications, Huizen, The Netherlands.
+ * Copyright (c) 2005 - 2007, Thales Communications, Huizen, The Netherlands.
  * Written by Erik Tromp.
  * All rights reserved.
  *
@@ -55,18 +55,21 @@
 #define IPV4_TYPE 0x0800
 
 /* BMF-encapsulated packets are Ethernet-IP-UDP packets, which start
- * with a 16-bytes BMF header (struct TEncapHeader), followed by the
+ * with a 8-bytes BMF header (struct TEncapHeader), followed by the
  * encapsulated Ethernet-IP packet itself */
 
 struct TEncapHeader
 {
+  /* Use a standard Type-Length-Value (TLV) element */
+  u_int8_t type;
+  u_int8_t len;
+  u_int16_t reserved; /* Always 0 */
   u_int32_t crc32;
-  u_int32_t futureExpansion1;
-  u_int32_t futureExpansion2;
-  u_int32_t futureExpansion3;
 } __attribute__((__packed__));
 
 #define	ENCAP_HDR_LEN ((int)sizeof(struct TEncapHeader))
+#define BMF_ENCAP_TYPE 1
+#define BMF_ENCAP_LEN 6
 
 struct TSaveTtl
 {
@@ -75,18 +78,14 @@
 } __attribute__((__packed__));
 
 int IsIpFragment(unsigned char* ipPacket);
-u_int16_t GetTotalLength(unsigned char* ipPacket);
-unsigned int GetHeaderLength(unsigned char* ipPacket);
+u_int16_t GetIpTotalLength(unsigned char* ipPacket);
+unsigned int GetIpHeaderLength(unsigned char* ipPacket);
 u_int8_t GetTtl(unsigned char* ipPacket);
 void SaveTtlAndChecksum(unsigned char* ipPacket, struct TSaveTtl* sttl);
 void RestoreTtlAndChecksum(unsigned char* ipPacket, struct TSaveTtl* sttl);
 void DecreaseTtlAndUpdateHeaderChecksum(unsigned char* ipPacket);
-u_int16_t GetEtherType(unsigned char* ethernetFrame);
-struct ip* GetIpHeader(unsigned char* ethernetFrame);
-unsigned char* GetIpPacket(unsigned char* ethernetFrame);
-u_int16_t GetFrameLength(unsigned char* ethernetFrame);
-void SetFrameSourceMac(unsigned char* ethernetFrame, unsigned char* srcMac);
-unsigned char* GetEthernetFrame(unsigned char* encapsulationUdpData);
+struct ip* GetIpHeader(unsigned char* encapsulationUdpData);
+unsigned char* GetIpPacket(unsigned char* encapsulationUdpData);
 u_int16_t GetEncapsulationUdpDataLength(unsigned char* encapsulationUdpData);
 
 #endif /* _BMF_PACKET_H */
diff -Nur olsrd-0.5.0.cvs/lib/bmf/src/PacketHistory.c olsrd-0.5.0/lib/bmf/src/PacketHistory.c
--- olsrd-0.5.0.cvs/lib/bmf/src/PacketHistory.c	2007-06-23 13:15:19.000000000 +0200
+++ olsrd-0.5.0/lib/bmf/src/PacketHistory.c	2007-05-13 04:30:30.000000000 +0200
@@ -1,6 +1,6 @@
 /*
  * OLSR Basic Multicast Forwarding (BMF) plugin.
- * Copyright (c) 2005, 2006, Thales Communications, Huizen, The Netherlands.
+ * Copyright (c) 2005 - 2007, Thales Communications, Huizen, The Netherlands.
  * Written by Erik Tromp.
  * All rights reserved.
  *
@@ -48,12 +48,13 @@
 #include <netinet/ip.h> /* struct iphdr */
 
 /* OLSRD includes */
+#include "defs.h" /* GET_TIMESTAMP, TIMED_OUT */
 #include "olsr.h" /* olsr_printf */
 
-/* NULLPlugin includes */
+/* Plugin includes */
 #include "Packet.h"
 
-static u_int32_t PacketHistory[HISTORY_TABLE_SIZE];
+static struct TDupEntry* PacketHistory[HISTORY_HASH_SIZE];
 
 #define CRC_UPTO_NBYTES 256
 
@@ -85,7 +86,7 @@
     crc ^= ((crc & 0xff) << 4) << 1;
   }
   return crc;
-}
+} /* CalcCrcCcitt */
 #endif
 
 /* -------------------------------------------------------------------------
@@ -120,8 +121,8 @@
       }
     }
     CrcTable[i] = crc;
-  }
-}
+  } /* for */
+} /* GenerateCrc32Table */
 
 /* -------------------------------------------------------------------------
  * Function   : CalcCrc32
@@ -142,32 +143,26 @@
     crc = (crc >> 8) ^ CrcTable[j];
   }
   return crc ^ 0xffffffffUL;
-}
+} /* CalcCrc32 */
 
 /* -------------------------------------------------------------------------
  * Function   : PacketCrc32
- * Description: Calculates the CRC-32 value for an Ethernet frame
- * Input      : ethernetFrame - the Ethernet frame
- *              len - the number of octets in the Ethernet frame
+ * Description: Calculates the CRC-32 value for an IP packet
+ * Input      : ipPacket - the IP packet
+ *              len - the number of octets in the IP packet
  * Output     : none
- * Return     : 32-bits hash value
+ * Return     : 32-bits CRC value
  * Data Used  : none
- * Notes      : The source and destination MAC address are not taken into account
- *              in the CRC calculation.
  * ------------------------------------------------------------------------- */
-u_int32_t PacketCrc32(unsigned char* ethernetFrame, ssize_t len)
+u_int32_t PacketCrc32(unsigned char* ipPacket, ssize_t len)
 {
-  ssize_t nCrcBytes;
   struct TSaveTtl sttl;
   struct ip* ipHeader;
   u_int32_t result;
 
-  assert(ethernetFrame != NULL);
+  assert(ipPacket != NULL);
 
-  /* Start CRC calculation at ethertype; skip source and destination MAC 
-   * addresses, and ethertype.
-   *
-   * Also skip TTL: in a multi-homed OLSR-network, the same multicast packet
+  /* Skip TTL: in a multi-homed OLSR-network, the same multicast packet
    * may enter the network multiple times, each copy differing only in its
    * TTL value. BMF must not calculate a different CRC for packets that
    * differ only in TTL. Skip also the IP-header checksum, because it changes
@@ -176,30 +171,36 @@
    *
    * Clip number of bytes over which CRC is calculated to prevent
    * long packets from possibly claiming too much CPU resources. */
-  nCrcBytes = len - IP_HDR_OFFSET;
-  assert(nCrcBytes > 0);
-  if (nCrcBytes > CRC_UPTO_NBYTES)
+  assert(len > 0);
+  if (len > CRC_UPTO_NBYTES)
   {
-    nCrcBytes = CRC_UPTO_NBYTES;
+    len = CRC_UPTO_NBYTES;
   }
 
-  SaveTtlAndChecksum(GetIpPacket(ethernetFrame), &sttl);
+  SaveTtlAndChecksum(ipPacket, &sttl);
 
-  ipHeader = GetIpHeader(ethernetFrame);
+  ipHeader = (struct ip*)ipPacket;
   ipHeader->ip_ttl = 0xFF; /* fixed value of TTL for CRC-32 calculation */
   ipHeader->ip_sum = 0x5A5A; /* fixed value of IP header checksum for CRC-32 calculation */
 
-  result = CalcCrc32(ethernetFrame + IP_HDR_OFFSET, nCrcBytes);
+  result = CalcCrc32(ipPacket, len);
 
-  RestoreTtlAndChecksum(GetIpPacket(ethernetFrame), &sttl);
+  RestoreTtlAndChecksum(ipPacket, &sttl);
   return result;
-}
+} /* PacketCrc32 */
 
-/* Calculates a 16-bit hash value from a 32-bit hash value */
-u_int16_t Hash16(u_int32_t hash32)
+/* -------------------------------------------------------------------------
+ * Function   : Hash
+ * Description: Calculates a hash value from a 32-bit value
+ * Input      : from32 - 32-bit value
+ * Output     : none
+ * Return     : hash value
+ * Data Used  : none
+ * ------------------------------------------------------------------------- */
+u_int32_t Hash(u_int32_t from32)
 {
-  return ((hash32 >> 16) + hash32) & 0xFFFFU;
-}
+  return ((from32 >> N_HASH_BITS) + from32) & ((1 << N_HASH_BITS) - 1);
+} /* Hash */
 
 /* -------------------------------------------------------------------------
  * Function   : InitPacketHistory
@@ -211,63 +212,61 @@
  * ------------------------------------------------------------------------- */
 void InitPacketHistory(void)
 {
-  memset(PacketHistory, 0, sizeof(PacketHistory));
-  GenerateCrc32Table();
-}
-
-/* -------------------------------------------------------------------------
- * Function   : MarkRecentPacket
- * Description: Record the fact that this packet was seen recently
- * Input      : hash16
- * Output     : none
- * Return     : none
- * Data Used  : PacketHistory
- * ------------------------------------------------------------------------- */
-void MarkRecentPacket(u_int16_t hash16)
-{
-  u_int32_t index;
-  uint offset;
-
-  index = hash16 / NPACKETS_PER_ENTRY;
-  assert(index < HISTORY_TABLE_SIZE);
+  int i;
 
-  offset = (hash16 % NPACKETS_PER_ENTRY) * NBITS_PER_PACKET;
-  assert(offset <= NBITS_IN_UINT32 - NBITS_PER_PACKET);
+  GenerateCrc32Table();
 
-  /* Mark as "seen recently" */
-  PacketHistory[index] = PacketHistory[index] | (0x3u << offset);
-}
+  for(i = 0; i < HISTORY_HASH_SIZE; i++)
+  {
+    PacketHistory[i] = NULL;
+  }
+} /* InitPacketHistory */
 
 /* -------------------------------------------------------------------------
  * Function   : CheckAndMarkRecentPacket
  * Description: Check if this packet was seen recently, then record the fact
  *              that this packet was seen recently.
- * Input      : hash16
+ * Input      : crc32 - 32-bits crc value of the packet
  * Output     : none
  * Return     : not recently seen (0), recently seen (1)
  * Data Used  : PacketHistory
  * ------------------------------------------------------------------------- */
-int CheckAndMarkRecentPacket(u_int16_t hash16)
+int CheckAndMarkRecentPacket(u_int32_t crc32)
 {
   u_int32_t index;
-  uint offset;
-  u_int32_t bitMask;
-  int result;
+  struct TDupEntry* walker;
+  struct TDupEntry* newEntry;
+
+  index = Hash(crc32);
+  assert(index < HISTORY_HASH_SIZE);
+
+  for (walker = PacketHistory[index]; walker != NULL; walker = walker->next)
+  {
+    if (walker->crc32 == crc32)
+    {
+      /* Found duplicate entry */
 
-  index = hash16 / NPACKETS_PER_ENTRY;
-  assert(index < HISTORY_TABLE_SIZE);
+      /* Always mark as "seen recently": refresh time-out */
+      walker->timeOut = GET_TIMESTAMP(HISTORY_HOLD_TIME);
 
-  offset =  (hash16 % NPACKETS_PER_ENTRY) * NBITS_PER_PACKET;
-  assert(offset <= NBITS_IN_UINT32 - NBITS_PER_PACKET);
+      return 1;
+    } /* if */
+  } /* for */
+
+  /* No duplicate entry found: create one */
+  newEntry = malloc(sizeof(struct TDupEntry));
+  if (newEntry != NULL)
+  {
+    newEntry->crc32 = crc32;
+    newEntry->timeOut = GET_TIMESTAMP(HISTORY_HOLD_TIME);
 
-  bitMask = 0x1u << offset;
-  result = ((PacketHistory[index] & bitMask) == bitMask);
-  
-  /* Always mark as "seen recently" */
-  PacketHistory[index] = PacketHistory[index] | (0x3u << offset);
+    /* Add new entry at the front of the list */
+    newEntry->next = PacketHistory[index];
+    PacketHistory[index] = newEntry;
+  }
 
-  return result;
-}
+  return 0;
+} /* CheckAndMarkRecentPacket */
   
 /* -------------------------------------------------------------------------
  * Function   : PrunePacketHistory
@@ -280,33 +279,37 @@
 void PrunePacketHistory(void* useless __attribute__((unused)))
 {
   uint i;
-  for (i = 0; i < HISTORY_TABLE_SIZE; i++)
+  for (i = 0; i < HISTORY_HASH_SIZE; i++)
   {
-    if (PacketHistory[i] > 0)
+    if (PacketHistory[i] != NULL)
     {
-      uint j;
-      for (j = 0; j < NPACKETS_PER_ENTRY; j++)
+      struct TDupEntry* nextEntry = PacketHistory[i];
+      struct TDupEntry* prevEntry = NULL;
+      while (nextEntry != NULL) 
       {
-        uint offset = j * NBITS_PER_PACKET;
+        struct TDupEntry* entry = nextEntry;
+        nextEntry = entry->next;
 
-        u_int32_t bitMask = 0x3u << offset;
-        u_int32_t bitsSeenRecenty = 0x3u << offset;
-        u_int32_t bitsTimingOut = 0x1u << offset;
-
-        /* 10 should never occur */
-        assert ((PacketHistory[i] & bitMask) != (0x2u << offset));
-        
-        if ((PacketHistory[i] & bitMask) == bitsSeenRecenty)
-        {
-          /* 11 -> 01 */
-          PacketHistory[i] &= ~bitMask | bitsTimingOut;
-        }
-        else if ((PacketHistory[i] & bitMask) == bitsTimingOut)
+        if (TIMED_OUT(entry->timeOut))
         {
-          /* 01 -> 00 */
-          PacketHistory[i] &= ~bitMask;
-        }
-      } /* for (j = ...) */
-    } /* if (PacketHistory[i] > 0) */
+          /* De-queue */
+          if (prevEntry != NULL)
+          {
+            prevEntry->next = entry->next;
+          }
+          else
+          {
+            PacketHistory[i] = entry->next;
+          } /* if */
+
+          /* De-allocate memory */
+          free(entry); 
+	      }
+	      else
+	      {
+	        prevEntry = entry;
+	      } /* if */
+      } /* while */
+    } /* if (PacketHistory[i] != NULL) */
   } /* for (i = ...) */
-}
+} /* PrunePacketHistory */
diff -Nur olsrd-0.5.0.cvs/lib/bmf/src/PacketHistory.h olsrd-0.5.0/lib/bmf/src/PacketHistory.h
--- olsrd-0.5.0.cvs/lib/bmf/src/PacketHistory.h	2007-06-23 13:15:19.000000000 +0200
+++ olsrd-0.5.0/lib/bmf/src/PacketHistory.h	2007-05-08 10:33:06.000000000 +0200
@@ -3,7 +3,7 @@
 
 /*
  * OLSR Basic Multicast Forwarding (BMF) plugin.
- * Copyright (c) 2005, 2006, Thales Communications, Huizen, The Netherlands.
+ * Copyright (c) 2005 - 2007, Thales Communications, Huizen, The Netherlands.
  * Written by Erik Tromp.
  * All rights reserved.
  *
@@ -41,24 +41,28 @@
  *
  * ------------------------------------------------------------------------- */
 
+/* System includes */
 #include <sys/types.h> /* ssize_t */
+#include <sys/times.h> /* clock_t */
 
-/* 2 bits per seen packet: 
- * 11 = "seen recently",
- * 01 = "timing out"
- * 00 = "not seen recently"
- * Note that 10 is unused */
-#define NBITS_PER_PACKET 2
-#define NBITS_IN_UINT16 (sizeof(u_int16_t) * 8)
-#define NBITS_IN_UINT32 (sizeof(u_int32_t) * 8)
-#define NPACKETS_PER_ENTRY (NBITS_IN_UINT32 / NBITS_PER_PACKET)
-#define HISTORY_TABLE_SIZE ((1 << NBITS_IN_UINT16) / NPACKETS_PER_ENTRY)
+#define N_HASH_BITS 12
+#define HISTORY_HASH_SIZE (1 << N_HASH_BITS)
+
+/* Time-out of duplicate entries, in milliseconds */
+#define HISTORY_HOLD_TIME 3000
+
+struct TDupEntry
+{
+  u_int32_t crc32;
+  clock_t timeOut;
+  struct TDupEntry* next;
+};
 
 void InitPacketHistory(void);
-u_int32_t PacketCrc32(unsigned char* ethPkt, ssize_t len);
-u_int16_t Hash16(u_int32_t hash32);
-void MarkRecentPacket(u_int16_t hash16);
-int CheckAndMarkRecentPacket(u_int16_t hash16);
+u_int32_t PacketCrc32(unsigned char* ipPkt, ssize_t len);
+u_int32_t Hash(u_int32_t from32);
+void MarkRecentPacket(u_int32_t crc32);
+int CheckAndMarkRecentPacket(u_int32_t crc32);
 void PrunePacketHistory(void*);
 
 #endif /* _BMF_PACKETHISTORY_H */
